package game 
{
	import game.objects.BackgroundObject;
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxSprite;
	import org.flixel.FlxU;
	/**
	 * ...
	 * @author Flashkick
	 */
	public class Background extends FlxGroup
	{
		[Embed(source = "../../media/images/BackgroundSky.png")] private var backgroundSky:Class;
		[Embed(source = "../../media/images/ForegroundTree.png")] private var foregroundTree:Class;
		[Embed(source = "../../media/images/BackgroundTree.png")] private var backgroundTree:Class;
		[Embed(source = "../../media/images/ForegroundCloud.png")] private var foregroundCloud:Class;
		[Embed(source = "../../media/images/BackgroundCloud.png")] private var backgroundCloud:Class;
		
		private var foreground:FlxGroup;
		private var foregroundCloudGroup:FlxGroup;
		private var background:FlxGroup;
		private var backgroundCloudGroup:FlxGroup;
		
		private var spawnTreeCounter:Number;
		private var spawnTreeTime:Number;
		private var bgSpawnTreeCounter:Number;
		private var bgSpawnTreeTime:Number;
		private var fgCloudCounter:Number;
		private var fgCloudTime:Number;
		private var bgCloudCounter:Number;
		private var bgCloudTime:Number;
		
		public function Background() 
		{
			super();
			foreground = new FlxGroup();
			foregroundCloudGroup = new FlxGroup();
			background = new FlxGroup();
			backgroundCloudGroup = new FlxGroup();
			
			var sky:FlxSprite = new FlxSprite();
			sky.loadGraphic(backgroundSky);
			add(sky);
			
			add(background);
			add(backgroundCloudGroup);
			add(foreground);
			add(foregroundCloudGroup);
			
			spawnTreeCounter = 5;
			spawnTreeTime = 0.3;
			bgSpawnTreeCounter = 5;
			bgSpawnTreeTime = 0.5;
			fgCloudCounter = 5;
			fgCloudTime = 0.5;
			bgCloudCounter = 5;
			bgCloudTime = 0.8;
		}
		
		override public function update():void 
		{
			var tree:BackgroundObject;
			var scale:Number;
			
			spawnTreeCounter += FlxG.elapsed;
			if (spawnTreeCounter >= spawnTreeTime) {
				tree = new BackgroundObject( -500, 50, 1000);
				tree.loadGraphic(foregroundTree);
				scale = FlxU.random() * 0.5 + 0.5;
				tree.scale.x = scale;
				tree.scale.y = scale;
				tree.y = FlxG.stage.stageHeight - tree.height * scale;
				foreground.add(tree);
				spawnTreeCounter = 0;
			}
			
			bgSpawnTreeCounter += FlxG.elapsed;
			if (bgSpawnTreeCounter >= bgSpawnTreeTime) {
				tree = new BackgroundObject( -500, 50, 500);
				tree.loadGraphic(backgroundTree);
				scale = FlxU.random() * 0.5 + 0.5;
				tree.scale.x = scale;
				tree.scale.y = scale;
				tree.y = FlxG.stage.stageHeight - tree.height * scale;
				background.add(tree);
				bgSpawnTreeCounter = 0;
			}
			
			fgCloudCounter += FlxG.elapsed;
			if (fgCloudCounter >= fgCloudTime) {
				tree = new BackgroundObject( -500, -100 + FlxU.random() * 150, 1000);
				tree.loadGraphic(foregroundCloud);
				scale = FlxU.random() * 0.5 + 0.5;
				tree.scale.x = scale;
				tree.scale.y = scale;
				foregroundCloudGroup.add(tree);
				fgCloudCounter = 0;
			}
			
			bgCloudCounter += FlxG.elapsed;
			if (bgCloudCounter >= bgCloudTime) {
				tree = new BackgroundObject( -500, -100 + FlxU.random() * 150, 500);
				tree.loadGraphic(backgroundCloud);
				scale = FlxU.random() * 0.5 + 0.5;
				tree.scale.x = scale;
				tree.scale.y = scale;
				backgroundCloudGroup.add(tree);
				bgCloudCounter = 0;
			}
			
			super.update();
		}
	}

}