package game 
{
	import flash.events.TextEvent;
	import game.objects.Bullet;
	import game.objects.Enemy;
	import game.objects.Player;
	import org.flixel.FlxEmitter;
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	import org.flixel.FlxU;
	/**
	 * ...
	 * @author Flashkick
	 */
	public class GameState extends FlxState
	{
		[Embed(source = "../../media/images/Gib.png")] private var gibImage:Class;
		[Embed(source = "../../media/images/Enemy.png")] private var enemyImage:Class;
		
		private var background:Background;
		
		private var spawnTimers:Array;
		
		private var player:Player;
		private var enemies:FlxGroup;
		private var bullets:FlxGroup;
		private var playerBullets:FlxGroup;
		
		private var gibs:FlxEmitter;
		
		private var kills:FlxText;
		private var heads:FlxText;
		
		override public function create():void 
		{
			FlxG.mouse.hide();
			
			spawnTimers = [];
			for (var i:int = 0; i < 3; i++) {
				spawnTimers.push(new SpawnTimer());
			}
			
			gibs = new FlxEmitter();
			gibs.delay = 3;
			gibs.setXSpeed( -150, 150);
			gibs.setYSpeed( -200, 0);
			gibs.setRotation( -720, 720);
			gibs.createSprites(gibImage, 100, 10, true, 0, 0);
			
			enemies = new FlxGroup();
			bullets = new FlxGroup();
			playerBullets = new FlxGroup();
			
			background = new Background();
			add(background);
			
			player = new Player(300, 300, enemies, bullets, playerBullets, gibs);
			add(player);
			
			add(enemies);
			add(playerBullets);
			add(bullets);
			add(gibs);
			
			var headSprite:FlxSprite = new FlxSprite(FlxG.stage.stageWidth - 90, -10);
			headSprite.loadGraphic(enemyImage);
			headSprite.scale.x = 0.5;
			headSprite.scale.y = 0.5;
			add(headSprite);
			
			heads = new FlxText(FlxG.stage.stageWidth - 105, 5, 100, "10");
			heads.alignment = "right";
			heads.color = 0x000000;
			heads.size = 18;
			add(heads);
			
			kills = new FlxText(FlxG.stage.stageWidth - 105, 35, 100, "Kills: 0");
			kills.alignment = "right";
			kills.color = 0x000000;
			kills.size = 16;
			add(kills);
			
			Statistics.reset();
		}
		
		private function spawnEnemy():void {
			var enemy:Enemy = new Enemy( -30, FlxU.random() * (stage.stageHeight - 110) + 60, bullets, playerBullets, player);
			enemies.add(enemy);
		}
		
		override public function update():void 
		{
			for (var i:int = 0; i < spawnTimers.length; i++) {
				spawnTimers[i].update(FlxG.elapsed, spawnEnemy);
			}
			
			heads.text = String(player.attachedBullets.members.length);
			kills.text = "Kills: " + String(Statistics.kills);
			
			super.update();
		}
	}

}