package game.objects 
{
	import org.flixel.FlxSprite;
	import org.flixel.FlxU;
	/**
	 * ...
	 * @author Flashkick
	 */
	public class PlayerBullet extends FlxSprite
	{
		[Embed(source = "../../../media/images/Enemy.png")] private var bulletImage:Class;
		
		private var player:Player
		public var isAttached:Boolean;
		
		private var offsetX:int;
		private var offsetY:int;
		private var centerX:int;
		private var centerY:int;
		
		private var speed:int;
		
		public function PlayerBullet(player:Player, angle:Number) 
		{
			super(player.x, player.y);
			this.player = player;
			isAttached = true;
			this.angle = angle;
			
			centerX = player.x;
			centerY = player.y;
			var maxDistance:Number = player.width / 2;
			var distance:int = int(FlxU.random() * maxDistance);
			
			offsetX = distance * (FlxU.random() * 2 - 1);
			offsetY = distance * (FlxU.random() * 2 - 1);
			
			loadRotatedGraphic(bulletImage, 36, -1, true);
			
			speed = 500;
		}
		
		override public function update():void 
		{
			if (isAttached) {
				centerX = player.x;
				centerY = player.y;
				x = centerX + offsetX;
				y = centerY + offsetY;
			}
			
			if (x < -width) {
				kill();
			}
				
			super.update();
		}
		
		public function shoot():void {
			isAttached = false;
			velocity.x = -speed;
			angularVelocity = -1000;
		}
	}

}