package menu 
{
	import game.GameState;
	import org.flixel.FlxButton;
	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	/**
	 * ...
	 * @author Flashkick
	 */
	public class MenuState extends FlxState
	{
		[Embed(source = "../../media/sound/ButtonClicked.mp3")] private var buttonClickSound:Class;
		[Embed(source = "../../media/images/BackgroundMenu.jpg")] private var backgroundMenuImage:Class;
		
		private var playButton:FlxButton;
		
		override public function create():void 
		{
			FlxG.mouse.show();
			FlxG.mouse.cursor.scale.x = 2;
			FlxG.mouse.cursor.scale.y = 2;
			
			var bgImage:FlxSprite = new FlxSprite();
			bgImage.loadGraphic(backgroundMenuImage);
			add(bgImage);
			
			
			playButton = new FlxButton(50, 50, onPlayButton);
			playButton.loadGraphic(new FlxSprite().createGraphic(200, 30, 0xff3a5c39), new FlxSprite().createGraphic(200, 30, 0xff729954));
			playButton.x = stage.stageWidth / 2 - playButton.width / 2;
			playButton.y = stage.stageHeight / 2 - playButton.height / 2 + 150;
			add(playButton);
			
			var text:FlxText = new FlxText(0, 0, 200, "[Z] Play Game");
			text.size = 16;
			text.alignment = "center";
			text.x = stage.stageWidth / 2 - text.width / 2;
			text.y = stage.stageHeight / 2 - text.height / 2 + 150;
			add(text);
		}
		
		override public function update():void 
		{
			if (FlxG.keys.Z) {
				onPlayButton();
			}
			
			super.update();
		}
		
		private function onPlayButton():void {
			if (!FlxG.fade.exists) {
				FlxG.fade.start(0xff000000, 1, onPlay);
				FlxG.play(buttonClickSound);
			}
		}
		
		private function onPlay():void {
			FlxG.state = new GameState();
		}
		
	}

}